package etapa5;
import java.util.Scanner;

public class Labirintos {

	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		//Laço que o número de casos de teste
		for (int i = sc.nextInt(); i > 0; i--) {
			//Armazena a largura do vetor
			int x = sc.nextInt();
			//Cria um vetor com o tamanho recebido
			boolean[][] grafo = new boolean[x][x];
			//Posição de inicial e final do labirinto
			int m = sc.nextInt();
			int n = sc.nextInt();
			//Número de linhas disponíveis
			int linhas = sc.nextInt();
			
			//assume-se que, inicialmente, que não há linhas iguais
			int resposta = linhas;
			//Laço para verificar se há linhas iguais.
			//Quando o programa recebe uma linha de entrada, ele muda o ponto para true
			//Caso outra linha equivalente a essa apareça na entrada, decrementa um da resposta, pois há uma linha repetida
			for (int j = 0; j < linhas; j++) {
				int inicio = sc.nextInt();
				int fim = sc.nextInt();
				if (grafo[inicio][fim] || grafo[fim][inicio])
					resposta--;
				else
					grafo[inicio][fim] = true;
			}
			//A resposta será o número de linhas, desconsiderando linhas iguais, vezes dois
			System.out.println(resposta*2);
			
		}
	}
}
'